module mdy_fifo_1_3(
    clk_in      ,
    clk_out     ,
    rst_n       ,

    b_rdy       ,
    data_in     ,
    data_in_vld ,

    data_out_vld,
    data_out    
    );

    parameter      DOUT_W =         8;
    parameter      DIN_W =         32;

    input                clk_in        ; 
    input                clk_out       ; 
    input                rst_n         ; 

    input                b_rdy         ; 
    input [DIN_W-1:0]    data_in       ; 
    input                data_in_vld   ; 
    output               data_out_vld  ;
    output[DOUT_W-1:0]   data_out      ;  

 

endmodule

