module mdy_fifo_1_4(
    clk_in      ,
    clk_out     ,
    rst_n       ,

    data_in_vld ,
    data_in     ,
    b_rdy       ,

    data_out_vld,
    data_out     
    );

    parameter      DIN_W  =         8;
    parameter      DOUT_W =        16;

    input                clk_in          ;   
    input                clk_out         ;   
    input                rst_n           ;
                                 
    input                data_in_vld     ;
    input[DIN_W-1:0]     data_in         ;
    input                b_rdy           ;
                              
    output               data_out_vld    ;
    output[DOUT_W-1:0]   data_out        ;
   

endmodule

