module mdy_fifo_1_8 (
    clk         ,
    rst_n       ,
    din         ,
    b_rdy       ,
    din_vld     ,
    din_sop     ,
    din_eop     ,

    dout        ,
    dout_vld    ,
    dout_sop    ,
    dout_eop       
    );

    parameter      DIN_W  =         32;
    parameter      DOUT_W =          8;
    input               clk         ;
    input               rst_n       ;
    input[DIN_W-1:0]    din         ; 
    input               b_rdy       ; 
    input               din_vld     ; 
    input               din_sop     ; 
    input               din_eop     ; 

    output[DOUT_W-1:0]  dout        ;
    output              dout_vld    ; 
    output              dout_sop    ; 
    output              dout_eop    ; 




endmodule

